unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl, StdCtrls, ExtCtrls, jpeg;

type
  TMainForm = class(TForm)
    Splitter2: TSplitter;
    Panel4: TPanel;
    Splitter1: TSplitter;
    DirLBox: TDirectoryListBox;
    FLBox: TFileListBox;
    Panel2: TPanel;
    DriveCmbBox: TDriveComboBox;
    Panel1: TPanel;
    PreViewPanel: TPanel;
    PreViewImage: TImage;
    Panel3: TPanel;
    FileNameLbl: TLabel;
    FileInfoLbl: TLabel;
    HelpBtn: TButton;
    procedure FLBoxClick(Sender: TObject);
    procedure PreViewImageClick(Sender: TObject);
    procedure MainKey(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FLBoxChange(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
    { Private declarations }
    procedure PrepareImage;
    function PictureInfoStr:string;
  public
    { Public declarations }
    function KeyWork(Key:word; Shift:TShiftState):boolean;
  end;

var
  MainForm: TMainForm;

implementation

uses ShowImageUn;

{$R *.DFM}

procedure TMainForm.PrepareImage;
var iw,ih:integer;
  aspect:real;
  sw,sh:integer;
begin
  PreViewImage.Stretch:=false;
  sw:=PreViewPanel.Width;
  sh:=PreViewPanel.Height;
  iw:=PreViewImage.Picture.width;
  ih:=PreViewImage.Picture.height;
  if (iw>sw)or(ih>sh)then begin
    aspect:=iw/ih;
    PreViewImage.Width:=sw;
    PreViewImage.Height:=trunc(sw/aspect);
    PreViewImage.Top:=(sh-PreViewImage.Height) div 2;
    PreViewImage.Left:=0;
    if PreViewImage.Height>sh then begin
      PreViewImage.Height:=sh;
      PreViewImage.Width:=trunc(sh*aspect);
      PreViewImage.Left:=(sw-PreViewImage.Width) div 2;
      PreViewImage.Top:=0;
    end;
    PreViewImage.Stretch:=true;
  end else
  begin
    PreViewImage.Width:=sw;
    PreViewImage.Height:=sh;
    PreViewImage.Left:=0;
    PreViewImage.Top:=0;
  end;
end;

procedure TMainForm.FLBoxClick(Sender: TObject);
var f:file of byte;
  fsize:integer;
begin
//  
  AssignFile(f,FLBox.FileName);
  Reset(f);
  fsize:=FileSize(f);
  CloseFile(f);
  PreViewImage.Picture.LoadFromFile(FLBox.FileName);
  FileNameLbl.Caption:=FLBox.FileName;
  FileInfoLbl.Caption:=IntToStr(PreViewImage.Picture.Width)+'x'
    +IntToStr(PreViewImage.Picture.Height)
    +' Size: '+IntToStr(fsize);
  PrepareImage;
end;



procedure TMainForm.PreViewImageClick(Sender: TObject);
begin
  if PreViewImage.Picture.Graphic<>nil then begin
    ScalePics:=true;
    ShowForm.AssignImage(PreViewImage.Picture,PictureInfoStr);
    ShowForm.ShowModal;
  end;
end;

procedure TMainForm.MainKey(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_ESCAPE then close;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  PrepareImage;
end;

function TMainForm.KeyWork(Key:word; Shift:TShiftState):boolean;
begin
  case Key of
    VK_DOWN, VK_RIGHT, VK_SPACE: begin
      if FLBox.ItemIndex+1<FLBox.Items.Count then begin
        FLBox.ItemIndex:=FLBox.ItemIndex+1;//
        FLBoxClick(self);//  
        ShowForm.AssignImage(PreViewImage.Picture,PictureInfoStr);
      end else ShowForm.ShowInfoStr;
      Result:=false;
    end;
    VK_UP, VK_LEFT: begin
      if FLBox.ItemIndex>0 then begin
        FLBox.ItemIndex:=FLBox.ItemIndex-1;
        FLBoxClick(self);
        ShowForm.AssignImage(PreViewImage.Picture,PictureInfoStr);
      end else ShowForm.ShowInfoStr;
      Result:=false;
    end;
  else
    Result:=true;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  KeyPressEvent:=KeyWork;
end;

//       
function TMainForm.PictureInfoStr: string;
begin
  Result:=FLBox.FileName+' ['+intToStr(FLBox.ItemIndex+1)
    +'/'+intToStr(FLBox.Items.Count)+']';
end;

procedure TMainForm.FLBoxChange(Sender: TObject);
begin
//     -  
  if FLBox.ItemIndex<0 then begin
    FileNameLbl.Caption:='No File';
    FileInfoLbl.Caption:='';
    PreViewImage.Picture.Bitmap.FreeImage;
    PreViewImage.Picture:=nil;
  end;
end;

procedure TMainForm.HelpBtnClick(Sender: TObject);
begin
  ShowMessage('  BMP  JPEG-'
    +#13#10#13#10
    +'   -    .'
    +#13#10#13#10
    +' :'
    +#13#10
    +'    -    ;'
    +#13#10
    +'   -     ;'
    +#13#10
    +'      -    .');
end;

end.
